#include "SevSeg.h"
#include "Rotary.h"

#define SW_RESET A0

Rotary r = Rotary(2, 3);
SevSeg sevseg;

byte numDigits = 4;
byte digitPins[] = {A1, A2, A3, A4};  // anode 1, anode 2, anode 3, anode 4
byte segmentPins[] = {6, 7, 8, 9, 10, 11, 12, 13}; // a, b, c, d, e, f, g, h
bool resistorsOnSegments = true;      // 'false' means resistors are on digit pins
byte hardwareConfig = COMMON_CATHODE; // see README.md for options
bool updateWithDelays = false;        // default 'false' is Recommended
bool leadingZeros = true;             // use 'true' if you'd like to keep the leading zeros
bool disableDecPoint = false;         // use 'true' if your decimal point doesn't exist or isn't connected

int8_t enc_dir = 0;
int16_t c = 0;
bool ch_flag  = true;
//--------------------------------------------------------------------------------------------------------
void setup() {
  pinMode(SW_RESET, INPUT_PULLUP);

  attachInterrupt(0, rotary_encoder, CHANGE);
  attachInterrupt(1, rotary_encoder, CHANGE);

  sevseg.begin(hardwareConfig, numDigits, digitPins, segmentPins, resistorsOnSegments,
               updateWithDelays, leadingZeros, disableDecPoint);

  sevseg.setBrightness(100);
}
// --------------------------------------------------------------------------------------------------------
void loop() {
  if (ch_flag) {
    ch_flag = false;
    c += enc_dir;
    if (c < 0)
      c = 9999;
    if (c > 9999)
      c = 0;
    show_count(c);
  }

  if (!digitalRead(SW_RESET)) {
    c = 0;
    show_count(c);
  }

  sevseg.refreshDisplay();            // must run repeatedly
}
// --------------------------------------------------------------------------------------------------------
void rotary_encoder() {
  uint8_t result = r.process();

  if (result) {
    ch_flag = true;
    if (result == DIR_CW)
      enc_dir = 1;
    else
      enc_dir = -1;
  }
}
// --------------------------------------------------------------------------------------------------------
void show_count(int16_t cc) {
  sevseg.setNumber(cc, 0);
}
